<template>
  <div class="login">

    <h2 class="title">{{ $t("login.标题") }}</h2>
    <div class="login-content">
      <!-- <div class="main-left"></div> -->
      <div class="main-right">
        <el-form ref="loginRef" :model="loginForm" :rules="loginRules" class="login-form">
          <h3 class="form-title">{{ $t("login.用户登录") }}</h3>
          <el-form-item prop="username">
            <el-input v-model="loginForm.username" type="text" size="large" autocomplete="off"
              :placeholder="$t('login.账号')">
              <template #prefix><svg-icon icon-class="user" class="el-input__icon input-icon" /></template>
            </el-input>
          </el-form-item>
          <el-form-item prop="password">
            <el-input v-model="loginForm.password" type="password" size="large" autocomplete="off"
              :placeholder="$t('login.密码')" @keyup.enter="handleLogin">
              <template #prefix><svg-icon icon-class="password" class="el-input__icon input-icon" /></template>
            </el-input>
          </el-form-item>
          <el-form-item prop="devCode" v-if="devStorageFlag">
            <el-select v-model="loginForm.devCode" :placeholder="tLang('device', '绑定设备')" size="large"
              style="width: 240px">
              <el-option v-for="item in devList" :key="item.id" :label="item.name" :value="item.code" />
            </el-select>
          </el-form-item>
          <el-form-item prop="code" v-if="captchaEnabled">
            <el-input v-model="loginForm.code" size="large" auto-complete="off" :placeholder="$t('login.验证码')"
              style="width: 63%" @keyup.enter="handleLogin">
              <template #prefix><svg-icon icon-class="validCode" class="el-input__icon input-icon" /></template>
            </el-input>
            <div class="login-code">
              <img :src="codeUrl" @click="getCode" class="login-code-img" />
            </div>
          </el-form-item>
          <el-checkbox v-model="loginForm.rememberMe" style="margin:0px 0px 15px 0px;">{{ $t("login.记住密码")
            }}</el-checkbox>
          <el-form-item style="width:100%;">
            <el-button :loading="loading" size="large" type="warning" color="#57667c" style="width:100%;"
              @click.prevent="handleLogin">
              <span v-if="!loading">{{ $t("login.登录") }}</span>
              <span v-else>{{ $t("login.登录中") }}...</span>
            </el-button>
            <div style="float: right;" v-if="register">
              <router-link class="link-type" :to="'/register'">{{ $t("login.立即注册") }}</router-link>
            </div>
          </el-form-item>
        </el-form>
      </div>

    </div>

    <!--  底部  -->
    <div class="el-login-footer">
      <span>{{ $t("login.版权") }}</span>
    </div>
  </div>
</template>

<script setup>
import { getCodeImg } from "@/api/login";
import Cookies from "js-cookie";
import { encrypt, decrypt } from "@/utils/jsencrypt";
import useUserStore from '@/store/modules/user'
import { getAll } from "@/api/pms/device";

const userStore = useUserStore()
const route = useRoute();
const router = useRouter();
const { proxy } = getCurrentInstance();
let devList = ref([]);
const loginForm = ref({
  username: "",
  password: "",
  rememberMe: false,
  code: "",
  uuid: "",
  devCode: "",
  sn: ""
});

const loginRules = {
  username: [{ required: true, trigger: "blur", message: "请输入您的账号" }],
  password: [{ required: true, trigger: "blur", message: "请输入您的密码" }],
  code: [{ required: true, trigger: "change", message: "请输入验证码" }]
};

const codeUrl = ref("");
const loading = ref(false);
// 验证码开关
const captchaEnabled = ref(false);
// 注册开关
const register = ref(false);
const redirect = ref(undefined);

let devStorageFlag = ref(false)
let tempItem = ref({})

watch(route, (newRoute) => {
  redirect.value = newRoute.query && newRoute.query.redirect;
}, { immediate: true });

function handleLogin() {
  proxy.$refs.loginRef.validate(valid => {
    if (valid) {
      loading.value = true;
      // 勾选了需要记住密码设置在 cookie 中设置记住用户名和密码
      if (loginForm.value.rememberMe) {
        Cookies.set("username", loginForm.value.username, { expires: 30 });
        Cookies.set("password", encrypt(loginForm.value.password), { expires: 30 });
        Cookies.set("rememberMe", loginForm.value.rememberMe, { expires: 30 });
      } else {
        // 否则移除
        Cookies.remove("username");
        Cookies.remove("password");
        Cookies.remove("rememberMe");
      }
      // 调用action的登录方法
      userStore.login(loginForm.value).then(() => {
        const query = route.query;
        const otherQueryParams = Object.keys(query).reduce((acc, cur) => {
          if (cur !== "redirect") {
            acc[cur] = query[cur];
          }
          return acc;
        }, {});
        router.push({ path: redirect.value || "/", query: otherQueryParams });
      }).catch((rej) => {
        if (rej.code == 510) {
          localStorage.removeItem('devStorage');
          loginForm.value.sn = ''
          loginForm.value.devCode = ''
          devStorageFlag.value = true
        }
        loading.value = false;
        // 重新获取验证码
        if (captchaEnabled.value) {
          getCode();
        }
      });
    }
  });
}

function getCode() {
  getCodeImg().then(res => {
    captchaEnabled.value = res.captchaEnabled === undefined ? true : res.captchaEnabled;
    if (captchaEnabled.value) {
      codeUrl.value = "data:image/gif;base64," + res.img;
      loginForm.value.uuid = res.uuid;
    }
  });
}

function getCookie() {
  const username = Cookies.get("username");
  const password = Cookies.get("password");
  const rememberMe = Cookies.get("rememberMe");
  loginForm.value = {
    username: username === undefined ? loginForm.value.username : username,
    password: password === undefined ? loginForm.value.password : decrypt(password),
    rememberMe: rememberMe === undefined ? false : Boolean(rememberMe)
  };
}

function getAllDev() {
  getAll().then(res => {
    devList.value = res.data;
    let devStorage = localStorage.getItem('devStorage') || ''
    if (devStorage !== '' && devStorage != '{}') {
      let jsonStorage = JSON.parse(devStorage)
      loginForm.value.sn = jsonStorage.sn
      loginForm.value.devCode = jsonStorage.devCode
      devStorageFlag.value = false

    } else {
      devStorageFlag.value = true
    }
  });
}

getCode();
getCookie();
getAllDev()



</script>

<style lang='scss' scoped>
.login {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url("../assets/images/login.png");
  background-repeat: no-repeat;
  background-size: 100% 100%;
  background-color: #57667c;

  .title {
    margin: 0px auto 20px auto;
    text-align: center;
    font-size: 28px;
    font-weight: 600;
    color: #fff;
  }

  // background-image: url("../assets/images/login-background.jpg");
  // background-size: cover;
  .login-content {
    width: 600px;
    height: 500px;
    display: flex;
    justify-content: center;
    align-items: center;
    box-sizing: border-box;
    border-radius: 20px;
    background-color: #fff;

    .main-right {
      transform: scale(1.4);

      .login-form {
        background: #ffffff;
        width: 285px;
        height: 340px;
        padding: 15px 15px 3px 21px;
        border-top-right-radius: 6px;
        border-bottom-right-radius: 6px;
        box-sizing: border-box;

        .form-title {
          margin: 0px auto 20px auto;
          text-align: center;
          color: #707070;
        }

        .el-input {
          height: 28px;

          input {
            height: 28px;
          }
        }

        .el-select {
          height: 28px;
          width: 100%;
        }

        .input-icon {
          height: 28px;
          width: 10px;
          margin-left: 0px;
        }
      }
    }

  }
}

:deep(.el-select__wrapper) {
  min-height: 28px;
}


.login-tip {
  font-size: 12px;
  text-align: center;
  color: #bfbfbf;
}

.login-code {
  width: 33%;
  height: 28px;
  float: right;

  img {
    cursor: pointer;
    vertical-align: middle;
  }
}

.el-login-footer {
  height: 28px;
  line-height: 28px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}

.login-code-img {
  height: 28px;
  padding-left: 12px;
}
:deep(.el-input__inner) {
  line-height: 18px;
}
</style>